'------------------------------------------------------------------------
'                          WeatherFI.vbs (v1.03)
'------------------------------------------------------------------------
' - Run "RunMeInBackground" -function in order to get your data updated.
'   Your antivirus-software may detect this as a malicious script, but
'   that's just because this writes a small temporary (.tmp) file into
'   your configs-folder.
'
' - Use "Add text file" -meter to view.
'
' - In TextFile Properties write down full path of your TEMP_DIR (*) (see below)
'   and filename weather.tmp into "Text File To Read From:" -datafield
'   (tex. c:\program files\samurize\configs\weather.tmp)
'   (* only if NO_TEMPFILE = FALSE)
'
'   Fileformat(**):
'   -----------
'   Line 1:	Location
'   Line 2:	Updated (date/time)
'   Line 3:	Temperature
'   Line 4:	Airpressure
'   Line 5:	Humidity
'   Line 6:	Wind direction
'   Line 7:	Wind speed
'   Line 8:	Rain
'   Line 9:	Clouds
'   Line 10:	Snow depth
'
'   (**) Some locations doesn't show all information. Take a look at the
'       output-file to see what information you get.
'
' - You may change user variables below.
'                                                                  - Sami 
'------------------------------------------------------------------------

Function RunMeInBackground

'------ User variables -------------
	const NO_TEMPFILE = FALSE	' TRUE - Returns whole thing into text %v-variable without saving tmp-file
					' FALSE - Saves everything into tmp-file
					' In case of a network failure, TRUE only displays "Network error" while FALSE leaves tmp-file intact.

	const TEMP_DIR = "F:\Samurize\"	' "String" - Where to save temp-file. ( tex. "C:\temp\" )
					' (leaving this empty ("") will save temp-file somewhere in the samurize-folder)

	const KAUPUNKI = "Tampere"	' Select a city from the list below:
					' Helsinki, Hmeenlinna, Ivalo, Joensuu, Jokioinen, Jyvskyl, Kajaani, Kilpisjrvi,
					' Kittil, Kokkola, Kotka, Kouvola, Kristiinankaupunki, Kuopio, Kuusamo, Lahti,
					' Lappeenranta, Maarianhamina, Mikkeli, Muonio, Nivala, Nurmes, Oulu, Pietarsaari,
					' Pori, Porvoo, Rovaniemi, Saariselk, Savonlinna, Seinjoki, Sodankyl, Tammisaari,
					' Tampere, Tornio, Turku, Utsjoki, Uusikaupunki, Vaasa, Vantaa, Varkaus, htri

					   ' What to display in front of the different info. You may also leave these empty ( "" ):
	const ASEMA = "Havaintoasema: "	   ' Location
	const PAIVA = "Tuorein havainto: " ' Last updated
	const LAMPO = ""	   ' Temperature
	const PAINE = "Paine: "		   ' Pressure
	const KOSTE = "Kosteus: "	   ' Humidity
	const PILVI = "Pilvisyys: "	   ' Clouds
	const SADEM = "Sademr: "	   ' Rain
	const LUMIM = "Lumen syvyys: "	   ' Snow depth
	const TUULI = "Tuulen nopeus: "	   ' Wind speed
	const TUULS = "Tuulen suunta: "	   ' Wind direction

	const DIRPO = "Pohjoistuulta"	' How to display wind directions
	const DIRIT = "Ittuulta"
	const DIRET = "Eteltuulta"
	const DIRLA = "Lnsituulta"
	const DIRKO = "Koillistuulta"
	const DIRKA = "Kaakkoistuulta"
	const DIRLO = "Lounaistuulta"
	const DIRLU = "Luoteistuulta"

	const SHOW_UNITS = FALSE	' TRUE = include units , FALSE = no units
	const SHOW_DATE = FALSE		' TRUE = include date (dd.mm.yyyy) , FALSE = no date
'-----------------------------------

	dim htmlResult,fs,f,outputti

	htmlResult = ReturnHTML("http://www.fmi.fi/saa/paikalli.html?kunta="& replace(KAUPUNKI,"","%E4"))

	if htmlResult <> "Network error" then
		aloitus = instr(htmlResult, "Havaintoasema:")
		if aloitus > 0 then
			lopetus = instr( aloitus, htmlResult, "<BR>")
			if lopetus > aloitus then
				outputti = mid( htmlResult, aloitus, lopetus-aloitus ) & "<BR>"
				aloitus = instr(lopetus, htmlResult, "Tuorein havainto:")
				if aloitus > 0 then
					lopetus = instr( aloitus, htmlResult, "<BR><IMG SRC=")
					if lopetus > aloitus then
						outputti = outputti & mid( htmlResult, aloitus, lopetus-aloitus )
					end if
				end if
			end if
		end if

		outputti = replace(outputti, Chr(13), "")
		outputti = replace(outputti, Chr(10), "")
		outputti = replace(outputti, "</b>", "")
		outputti = replace(outputti, "</B>", "")
		outputti = replace(outputti, "<I>", "")
		outputti = replace(outputti, "</I>", "")
		outputti = replace(outputti, "&nbsp;", " ")
		outputti = replace(outputti, "<B>", "")
		outputti = replace(outputti, "&deg;", "")
		outputti = replace(outputti, "<BR>", Chr(13) & Chr(10))
		outputti = replace(outputti, "C ", "C" & Chr(13) & Chr(10))
		outputti = replace(outputti, "hPa ", "hPa" & Chr(13) & Chr(10))
		outputti = replace(outputti, "m/s ", "m/s" & Chr(13) & Chr(10))
		outputti = replace(outputti, ") ", ")" & Chr(13) & Chr(10))
		outputti = replace(outputti, "% ", "%" & Chr(13) & Chr(10))
		outputti = replace(outputti, "tuulta ", "tuulta" & Chr(13) & Chr(10) & TUULI)

		if SHOW_DATE = FALSE then	
			aloitus = instr(outputti, "Tuorein havainto: ")
			if aloitus > 0 then
				outputti = replace(outputti, mid( outputti, aloitus+18, 11 ), "")
			end if
		end if

		outputti = replace(outputti, " lmptila ", LAMPO)
		outputti = replace(outputti, "paine ", PAINE)
		outputti = replace(outputti, "kosteus ", KOSTE)
		outputti = replace(outputti, "pilvisyys ", PILVI)
		outputti = replace(outputti, "sademr ", SADEM)
		outputti = replace(outputti, "Havaintoasema: ", ASEMA)
		outputti = replace(outputti, "Tuorein havainto: ", PAIVA)
		outputti = replace(outputti, " lumen syvyys ", Chr(13) & Chr(10) & LUMIM)

		outputti = replace(outputti, "pohjoistuulta", TUULS & DIRPO)
		outputti = replace(outputti, "ittuulta", TUULS & DIRIT)
		outputti = replace(outputti, "eteltuulta", TUULS & DIRET)
		outputti = replace(outputti, "lnsituulta", TUULS & DIRLA)
		outputti = replace(outputti, "koillistuulta", TUULS & DIRKO)
		outputti = replace(outputti, "kaakkoistuulta", TUULS & DIRKA)
		outputti = replace(outputti, "lounaistuulta", TUULS & DIRLO)
		outputti = replace(outputti, "luoteistuulta", TUULS & DIRLU)

		if SHOW_UNITS = FALSE then
			outputti = replace(outputti, " C", "")
			outputti = replace(outputti, " hPa", "")
			outputti = replace(outputti, " %", "")
			outputti = replace(outputti, " m/s", "")
			outputti = replace(outputti, " mm", "")
			outputti = replace(outputti, " cm", "")
		end if

		outputti = replace(outputti, Chr(13)&Chr(10)&Chr(13)&Chr(10), Chr(13)&Chr(10))

		if NO_TEMPFILE = FALSE then
			outputti = outputti & (Chr(13) & Chr(10))
			set fs=CreateObject("Scripting.FileSystemObject")
			set f=fs.CreateTextFile(TEMP_DIR&"weather.tmp",true)
			f.write(outputti)
			f.close
			set f=nothing
			set fs=nothing
		else
			RunMeInBackground = replace(outputti, (Chr(13) & Chr(10)), "%b")
		end if
	else
		RunMeInBackground = htmlResult
	end if

End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")
	On Error Resume Next
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	if err = 0 then
		HTML = objXMLHTTP.responseBody
		Set objRS = CreateObject("ADODB.Recordset")
		objRS.Fields.Append "txt", 200, 35000, &H00000080
		objRS.Open
		objRS.AddNew
		objRS.Fields("txt").AppendChunk HTML
		ReturnHTML = objRS("txt").Value
		objRS.Close
		Set objRS = Nothing
	else
		ReturnHTML = "Network error"
	end if
	On Error GoTo 0
	Set objXMLHTTP = Nothing
End Function
